#!"\xampp\perl\bin\perl.exe"

#monitor.pl
my $ver="2024.04.27";

#lib and path are set by startscript
use lib "/xampp/web-gui/data/cs_server/CGI";

# path to serverscript
$spath="/xampp/web-gui/data/cs_server";

#tmpfolder
$tpath="/xampp/web-gui/tmp";

use strict;
use utf8;

#use File::stat;
use Fcntl qw(:flock);                                        # filelocking

# auto-flush
$| = 1;

use vars qw(@f $client $ip $cmd $reply $t $tpath $wpath $dpath $spath $p_zfsmin $p_zpoolmin $last);

# is this windows?
my $dn = $^O;                                   # distribution from Perl ex MSWin32

my $perl="perl";                                # perl in path
if ($dn=~/mswin/i){
    $perl="c:/xampp/perl/bin/perl.exe";         # Windows
}

print "\ninitiate monitor service".`ver`."\n";

# example for ps commands
#print `powershell.exe -command \"get-disk | select size\";`;

#read always
$p_zfsmin='sharesmb,sharenfs,name,type,creation,used,avail,refer,ratio,mounted,origin,quota,reservation,recordsize,mountpoint,compression,atime,rdonly,snapdir,aclmode,aclinherit,canmount,version,utf8only,normalization,case,nbmand,refquota,refreserv,guid,primarycache,secondarycache,dedup,sync,clones,encryption,keylocation,keyformat,pbkdf2iters,encroot,keystatus,special_small_blocks,driveletter';  # min zfs properties
$p_zpoolmin='name,size,cap,altroot,health,guid,version,autoreplace,failmode,autoexpand,dedup,free,allocated,frag,checkpoint,autotrim,readonly';


$t=&get_mydate;
&my_write("$spath/tmp/monitor.log","monitor started $t\n");

while (1) {
     # date and time
     #print "###############\nmonitor service $ver";
     #$t=time();
     #print ".$t\n";

     #activity, create basic .stat
     # filename for caching
     # get filename ip_cmd_hash           # max 64 B
     # my $h  = sha256_hex($cmd);         # sha of cmd
     # $t=substr($cmd,0,30);              # first 30 char of cmd
     # my $filename="$ip\_$t\_$h";        # ip_cmd_hash
     # $filename=substr($filename,0,55);  # shorten to 55, real cmd is verified via file.last

     $last=&my_age();                           # how old in s is activity.log (updated by server.pl writefile or local on cache read)

     # print "last activity: $last s\n";
     if (!($last > 60)) {                       # 1 min interval for data reload
           sleep(60-$last);
           next;
     }  # nothing to log

     # del old tmp files
     @f = glob("$spath/tmp/*.data");
     foreach my $filename (@f) {
        if ($last > 300) { unlink($filename); }    #  5 min cache
     }
     @f = glob("$spath/tmp/*.last");
     foreach my $filename (@f) {
        if ($last > 300) { unlink($filename); }
     }

     # command.log und background.log
     @f = glob("$spath/tmp/*.log");
     foreach my $filename (@f) {
        if ($last > 24*3600) { unlink($filename); }   # 24h cache
     }

     # on activity, read .last (time()\nfullcmd and recreate .data
     #1.1.1.10_12345abcde.data and .last with time\n
     #cmd
     #todo

     sleep(10);          # intervall for new data
}

#############        #opt, todo
sub my_stat {
#############
    # zpool iostat -vy 1 1  (1s intervall)  for io load
    #root@pve:~# zpool iostat -vy 1 1
    #              capacity     operations     bandwidth
    #pool        alloc   free   read  write   read  write
    #----------  -----  -----  -----  -----  -----  -----
    #tank        1.79G  1.96G      0      0      0      0
    #  sdb        926M   994M      0      0      0      0
    #  sdc        904M  1016M      0      0      0      0
    #----------  -----  -----  -----  -----  -----  -----

    # zpool status (bad pools, disks)

    # zpool list (cap, free health)
    # zpool list -H -o cap,health
    # PS C:\Users\me> zpool list
    # NAME   SIZE  ALLOC   FREE  CKPOINT  EXPANDSZ   FRAG    CAP  DEDUP    HEALTH  ALTROOT
    # tank  5.50G  1.25M  5.50G        -         -     0%     0%  1.00x    ONLINE  -

    # jobs (from local jobs.log)

    # top -n 1 (ausser win und Solaris)
    # top -n 1
    # top - 20:32:18 up 24 days,  1:58,  2 users,  load average: 0.07, 0.04, 0.00
    # Tasks: 207 total,   1 running, 206 sleeping,   0 stopped,   0 zombie
    # %Cpu(s): 50.0 us, 50.0 sy,  0.0 ni,  0.0 id,  0.0 wa,  0.0 hi,  0.0 si,  0.0 st
    # MiB Mem :   2964.4 total,   1331.1 free,   1279.1 used,    550.0 buff/cache
    # MiB Swap:   1024.0 total,   1024.0 free,      0.0 used.   1685.3 avail Mem

    # PID USER      PR  NI    VIRT    RES    SHR S  %CPU  %MEM     TIME+ COMMAND
    # 475933 root      20   0   11604   5376   3328 R  11.8   0.2   0:00.03 top
    # ..

    # load average: 0.07, 0.04, 0.00
    # 0.07: Die durchschnittliche CPU-Auslastung in der letzten Minute war 7%.
    # 0.04: Die durchschnittliche CPU-Auslastung in den letzten 5 Minuten war 4%.
    # 0.00: Die durchschnittliche CPU-Auslastung in den letzten 15 Minuten war 0%.


    # windows
    # wmic cpu get loadpercentage
}

sub my_add {           # add ("path/filename","data",);  max 50 lines
##############

    my $file = $_[0];
    my $data = $_[1];
    my @old;

    ##########################
    my $lock="$spath/tmp/log.lock";
    open (X,"<$lock");
      flock(X, LOCK_EX);
          #
          open (F,"<$file");                      # old file
                flock(F, LOCK_EX);
                @old=<F>;
          close (F);

          if (@old > 100) {                       # max 100 lines
                     $t=@old-100;
                     splice(@old,100,$t);
          }

         $t=join("",@old);
         open (PF, ">$file");
            flock(PF, LOCK_EX);
            print PF "$t\n$data";                 # programm must add \n if needed to allow added strings
         close (PF);

    close (X);                                    # close lock


    #########################

    return();
}

sub my_write {           #   write ("path/filename","data",);
##############
    my $file = $_[0];
    my $data = $_[1];

    open(my $fh,">$file");
      flock($fh, LOCK_EX);
        print $fh "$data\n";
      flock($fh, LOCK_UN);
    close($fh);

    return();
}

sub my_read {           # read   read("path/filename");
##############
    my $file = $_[0];

    my $data="";
    my @data=();

    if (-f $file) {
        #
        open(my $fh, "<$file");
          flock($fh, LOCK_EX);
             @data = <$fh>;
          flock($fh, LOCK_UN);
        close($fh);
        $data=join("",@data);

    } else {
         $data="$file not found";
    }
    return($data);
}

############   fileage tempfile in s
sub my_age {
###########
    # any write or add updates tmpfolder/activity.log with a date() stamp.
    # to sync with monitor.pl
    # this sub reads activity.log and returns age in s

    my $file = "$spath/tmp/activity.log";
    if (!(-f $file)) { return "-1"; }        # file not found

    my $r=&my_read($file);  # last access
    $t=time();
    my $old=$t-$r;  # current - last in s

    return($old);
}

sub get_mydate {                # setzt datumsvariablen
###########
 my ($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst) = localtime(time);
 $mon++;
 if ($sec < 10) { $sec = "0$sec"; }
 if ($min < 10) { $min = "0$min"; }
 if ($hour < 10) { $hour = "0$hour"; }
 if ($mday < 10) { $mday = "0$mday"; }
 if ($mon < 10) { $mon = "0$mon"; }
 $year=1900+$year;
 return("$year\.$mon\.$mday\.$hour\.$min\.$sec");
}


#1;